package com.bzd.web.controller.kc.crk;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.kc.crk.SKcCrkDzysEmployeesignaturestatusService;

import java.util.List;

/**
*
* 电子验收配置 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-14
*/
@Controller
@RequestMapping(value = "kc/skccrkdzysemployeesignaturestatus")
public class SKcCrkDzysEmployeesignaturestatusController extends BaseController {

    // 页面跳转前缀
    private String prefix = "kc/crk";

    @Autowired
    private SKcCrkDzysEmployeesignaturestatusService sKcCrkDzysEmployeesignaturestatusService;

    /**
    * 电子验收配置 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("kc:crk:view")
    @GetMapping("/sKcCrkDzysEmployeesignaturestatusAdd")
    public String add() {
        return prefix + "/SKcCrkDzysEmployeesignaturestatusAdd";
    }

    /**
    * 电子验收配置 新增
    *
    * @return
    */
    @Log(title = "电子验收配置新增", businessType = BusinessType.INSERT)
    @PostMapping("/sKcCrkDzysEmployeesignaturestatusAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sKcCrkDzysEmployeesignaturestatusService.addSKcCrkDzysEmployeesignaturestatus(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 电子验收配置 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("kc:crk:view")
    @GetMapping("/sKcCrkDzysEmployeesignaturestatusView")
    public String skccrkdzysemployeesignaturestatusListView() {
        return prefix + "/SKcCrkDzysEmployeesignaturestatusList";
    }

    /**
    * 电子验收配置 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:crk:sKcCrkDzysEmployeesignaturestatusList")
    @PostMapping("/sKcCrkDzysEmployeesignaturestatusList")
    @ResponseBody
    public TableDataInfo skccrkdzysemployeesignaturestatusList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sKcCrkDzysEmployeesignaturestatusService.findSKcCrkDzysEmployeesignaturestatusList(pd);
        return getDataTable(pageData);
    }

    /**
    * 电子验收配置 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:crk:remove")
    @Log(title = "电子验收配置删除", businessType = BusinessType.DELETE)
    @PostMapping("/sKcCrkDzysEmployeesignaturestatusRemove")
    @ResponseBody
    public AjaxResult skccrkdzysemployeesignaturestatusRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sKcCrkDzysEmployeesignaturestatusService.SKcCrkDzysEmployeesignaturestatusRemove(pd);
        return toAjax(integer);
    }

    /**
    * 电子验收配置 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("kc:crk:edit")
    @GetMapping("/sKcCrkDzysEmployeesignaturestatusEdit/{id}")
    public String skccrkdzysemployeesignaturestatusView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sKcCrkDzysEmployeesignaturestatusService.findSKcCrkDzysEmployeesignaturestatusList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/skccrkdzysemployeesignaturestatusPageEdit";
        }
        return prefix+ "/skccrkdzysemployeesignaturestatusEdit";
    }

    /**
    * 电子验收配置保存修改的数据
    */
    @RequiresPermissions("kc:crk:edit")
    @Log(title = "电子验收配置修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sKcCrkDzysEmployeesignaturestatusEdit")
    @ResponseBody
    public AjaxResult skccrkdzysemployeesignaturestatusEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sKcCrkDzysEmployeesignaturestatusService.updateSKcCrkDzysEmployeesignaturestatus(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表skccrkdzysemployeesignaturestatus with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表skccrkdzysemployeesignaturestatus with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
